//+------------------------------------------------------------------+
//|                                                      ROC2_VG.mq4 |
//|                        Copyright  2006, Vladislav Goshkov (VG). |
//|                                                      4vg@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Vladislav Goshkov"
#property link      "4vg@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_level1  0.005
#property indicator_level2  0.002
#property indicator_level3  0.00
#property indicator_level4  -0.002
#property indicator_level5  -0.005

//---- input parameters
extern int ROCPeriod  = 8;
extern int ROCType    = 0;
extern int MaPeriod   = 9;
extern int MaType     = MODE_SMA;
//---- buffers
double Buffer1[];
double Buffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  
{
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer2);
   string Type1="";
   switch(ROCType)
   {
     case 1 : Type1="MOM";     break; 
     case 2 : Type1="ROC";     break; 
     case 3 : Type1="ROCP";    break; 
     case 4 : Type1="ROCR";    break; 
     case 5 : Type1="ROCR100"; break; 
     default: Type1="ROCP";    break;
   }

   IndicatorShortName("ROC + ma( "+Type1+" = "+ROCPeriod+","+MaPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start(){
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
      double price     = Close[i];
      double prevPrice = Close[i+ROCPeriod];
      if (prevPrice==0) prevPrice = price;
      switch(ROCType)
      {
         case 1 : Buffer1[i]= (price - prevPrice);         break; //"MOM"
         case 2 : Buffer1[i]= ((price/prevPrice)-1)*100;   break; //"ROC"
         case 3 : Buffer1[i]= (price-prevPrice)/prevPrice; break; //"ROCP"
         case 4 : Buffer1[i]= (price/prevPrice);           break; //"ROCR"
         case 5 : Buffer1[i]= (price/prevPrice)*100;       break; //"ROCR100"
         default: Buffer1[i]= (price-prevPrice)/prevPrice; break;
      }
   }
   for(i=limit; i>=0; i--) Buffer2[i] = iMAOnArray(Buffer1,0,MaPeriod,0,MaType,i);
   return(0);
}